# FFTrack

## Description
FFTrack is a Python-based music recognition tool that allows users to identify songs from audio input. It uses Fast Fourier Transform (FFT) for audio processing.

## Features
- Audio processing with Fast Fourier Transform (FFT)
- Command line interface for easy usage
- Song recognition from audio recording
- Song recognition from audio files
- Simple database for storing song information

## Installation
To install FFTrack, follow these steps:
1. Clone the repository to your local machine:
2. Install the package using the following command:
```
pip install .
```
3. Install the required dependencies using the following command:
```
pip install -r requirements.txt
```
4. Verify the installation by running the following command:
```
fftrack --help
```

## Usage
### Database Setup
To create the database, run the following command in your terminal:
```
populate-database
```


To record audio and identify the song, run the following command in your terminal:
```
fftrack listen
```

To identify the song from an audio file, run the following command in your terminal:
```
fftrack identify <path_to_audio_file>
```


## Configuration
To configure FFTrack, run the following command in your terminal (not available yet):
```
fftrack config
```

[//]: # (## Contributing)

[//]: # (If you want to contribute to this project, please follow these steps:)


## License

[//]: # (This project is licensed under the [MIT License]&#40;LICENSE&#41;.)

## Contact
